<template>
	<div>
		<h4 class="b-gap-1">Kommentare</h4>

		<section class="cards" v-if="isLoggedIn">
			<form v-on:submit.prevent>
				<div class="card-body flex">
					<textarea ref="comment" v-model="form.comment" class="input input--full-w" placeholder="..."></textarea>
					<button class="button button--mobile-stretch" @click="postComment">Senden</button>
				</div>
			</form>
		</section>

		<!--		Comments-->
		<loader v-if="isLoading" />

		<paginator @clicked="fetchComments" :limiter="2" :total-pages="totalPages" :current-page="currentPage" />

		<comment
			v-for="(comment, index) in comments"
			:key="index"
			:comment="comment"
			:total="comments.length"
			:index="index"
		/>

		<div v-if="!comments.length" class="notification-simple">
			Keine Kommentare vorhanden.
		</div>

		<paginator @clicked="fetchComments" :limiter="2" :total-pages="totalPages" :current-page="currentPage" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>
</template>

<script>
import Comment from "@/components/Comment";
import SystemMessage from "@/components/SystemMessage";
import Loader from "@/components/Loader";
import Paginator from "@/components/Paginator";

export default {
	name: "EventComments",
	components: {
		Paginator,
		Loader,
		SystemMessage,
		Comment
	},
	props: {
		eventId: String
	},
	data: () => ({
		isLoading: false,
		form: {
			comment: ""
		},
		comments: {},
		totalPages: 0,
		currentPage: 1,
		sysMsg: undefined
	}),
	methods: {
		async fetchComments(page = 1) {
			this.isLoading = true;
			const response = await this.$http.get("/api/comments/event/" + this.eventId + "/" + page);
			this.currentPage = page;
			this.totalPages = response.data.totalPages;
			this.comments = response.data.paginatedContent;
			this.isLoading = false;
		},

		async postComment() {
			this.sysMsg = "";

			const commentDTO = {
				"eventId": parseInt(this.eventId),
				"userId": this.$store.getters.getUserId,
				"comment": this.form.comment
			}

			let verified = this.globalValidateForm();

			if(!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			try {
				const response = await this.$http.post("/api/comment", commentDTO);
				switch (response.status) {
					case 200:
						this.sysMsg = "Erfolgreich eingetragen.";
						this.form.comment = "";
						await this.fetchComments();
						break;
					case 204:
						this.sysMsg = "Fehlende Eingaben";
						break;
					case 404:
						this.sysMsg = "User ID nicht gefunden. Bitte melden Sie sich erneut an.";
						break;
				}
			} catch (e) {
				console.error(e);
			}
		}
	},
	computed: {
		isLoggedIn() {
			return this.$store.getters.isLoggedIn;
		}
	},
	mounted() {
		this.fetchComments();
	}
}
</script>

<style scoped>

</style>